

% to color code
\usepackage{listings}
\usepackage{textcomp}

\lstset{upquote=true,escapechar={§}}

\lstdefinestyle{gPython }
{ %configuration de listings %
 backgroundcolor=\color{LBluePy},                 % choose the background color; you must add \usepackage{color} or \usepackage{xcolor}
 basicstyle=\fontsize{8}{8}\selectfont\ttfamily,  % the size of the fonts that are used for the code
 breakatwhitespace=false,                         % sets if automatic breaks should only happen at whitespace
 columns=fixed,
 breaklines=true,                                 % sets automatic line breaking
 captionpos=b,                                    % sets the caption-position to bottom
 commentstyle=\color{DarkRed},                    % comment style
 deletekeywords={},                               % if you want to delete keywords from the given language
 %escapeinside={\%*}{*)},                         % if you want to add LaTeX within your code
 extendedchars=true,                              % lets you use non-ASCII characters; for 8-bits encodings only, does not work with UTF-8
 literate={à}{{\`a}}1 {ç}{{\c{c}}}1 {Ç}{{\c{C}}}1 {é}{{\'e}}1 {è}{{\`e}}1,
 frame=single,                                    % none,leftline,topline,bottomline,lines(top and bottom),singlefor single frames, or shadowbox tb : top and bottom %
 frameround=ffff,                                 %
 identifierstyle=\color{black},                   %
 keywordstyle=\color{DarkOrange},                 %
 language=Python,                                 % the language of the code
 morekeywords={[2]None,True,False,@staticmethod,dir,len,map,open,print,float,isinstance,zip,repr},keywordstyle={[2]\bfseries\Mauve},
 morekeywords={[3]as},keywordstyle={[3]\bfseries},
 numbers=left,                                    % where to put the line-numbers; possible values are (none, left, right)
 numbersep=6pt,                                   % how far the line-numbers are from the code
 numberstyle=\tiny\color{BluePy},          % the style that is used for the line-numbers
 rulecolor=\color{BluePy},                        % if not set, the frame-color may be changed on line-breaks within not-black text (e.g. comments (green here))
 showspaces=false,                                % show spaces everywhere adding particular underscores; it overrides 'showstringspaces'
 showstringspaces=false,                          % underline spaces within strings only
 showtabs=false,                                  % show tabs within strings adding particular underscores  
 stepnumber=1,                                    % the step between two line-numbers. If it's 1, each line will be numbered 
 stringstyle=\color{DarkGreen},                   % string literal style
 morestring=[s][\color{DarkGreen}]{u'}{'},
 morestring=[s][\color{DarkGreen}]{u"}{"},
 morestring=[s][\color{DarkGreen}]{r'}{'},
 morestring=[s][\color{DarkGreen}]{r"}{"},
 tabsize=2,                                       % sets default tabsize to 2 spaces 
 %title=\lstname                                   % show the filename of files included with \lstinputlisting; also try caption instead of title
 xleftmargin=0.1cm,
 xrightmargin=0cm
}

\lstdefinestyle{gStyle}{    
 upquote=true,
 basicstyle=\ttfamily\footnotesize\color{Chocolate},
 columns=fullflexible,
 literate={*}{{\char42}}1 {-}{{\char45}}1,
 numberstyle=\ttfamily\tiny\color{black},
 backgroundcolor=\color{yellow!25}, 
 showspaces=false,
 showstringspaces=false,
 showtabs=false,
 columns=fixed,
 frame=single,
 tabsize=2,
 breaklines=true,
 breakatwhitespace=false,
 title=\lstname,
 numbers=none,
 rulecolor=\color{gray!40},
 keywordstyle=\color{blue},
 commentstyle=\DarkGreen,
 stringstyle=\color{red},
 identifierstyle=\ttfamily,
 basewidth=0.5em
}


\lstdefinelanguage{granXml}[]{XML}{
  language=XML,
  columns=fullflexible,
  morekeywords={PlugIn},
}

\lstdefinestyle{granInXml}{
  language=granXml,
  style=gStyle,
  basicstyle=\ttfamily\color{Chocolate},
  markfirstintag=true,
  tagstyle=\color{Chocolate}
}

\lstdefinestyle{granXml}{
  language=granXml,
  style=gStyle,
  markfirstintag=true,
  tagstyle=\color{Chocolate}
}

\lstdefinestyle{granXmlTiny}{
  style=granXml,
  basicstyle=\ttfamily\tiny\color{Chocolate},
  frame=none
}

\lstdefinelanguage{granCpp}[]{c++}{morekeywords={Frame, Vector, Point, Quaternion, DiscreteDomain, _3D, Geom, DiscreteElement, SetOf<DiscreteElement>, SetOf, SetOfMap, DE, DEM,DiscreteShape, DiscreteShapeT, Cylinder, Sphere, Box, Util, std, cout, end, vector, map, endl, CYLINDER, SetOfDE, ComputeProblem, PROB, Sensor}
}


\lstdefinestyle{granCpp}{language=granCpp,style=gStyle}

\lstdefinelanguage{granPython}[]{Python}{
}

\lstdefinestyle{granPython}{language=granPython}%,style=gPython}

\lstdefinelanguage{granMake}[]{make}{
}

\lstdefinestyle{granMake}{language=granMake,style=gStyle}

\lstdefinelanguage{granTerminal}[]{}{
    morekeywords={},
    morecomment=[s][\color{black}]{jlc@Mike}{$},
    morecomment=[s][\color{black}]{jlc@mike}{$},
    morecomment=[s][\color{black}]{jlc@nono}{$}, %$
    morecomment=[l]{\#}
}

\lstdefinestyle{granTerminal}{
  language=granTerminal,
  style=gStyle,
  backgroundcolor=\color{green!10},
}

\lstdefinestyle{granTerminalTiny}{
  style=granTerminal,
  basicstyle=\ttfamily\tiny\color{Chocolate},
}



